create table um_users (id bigint not null, user_name varchar(255) not null unique, password varchar(255) not null, primary key (id));
create table um_user_attributes (id bigint not null, attr_name varchar(255) not null, attr_value varchar(255), user_id bigint not null, primary key (id));
create table um_roles (id bigint not null, role_name varchar(255) not null unique, primary key (id));
create table um_role_attributes (id bigint not null, attr_name varchar(255) not null, attr_value varchar(255), role_id bigint not null, primary key (id));
create table um_permissions (id bigint not null, resource_id varchar(255) not null, action varchar(255) not null, primary key (id));
create table um_role_permissions (id bigint not null, permission_id bigint not null, is_allowed smallint not null, role_id bigint not null, primary key (id));
create table um_user_permissions (id bigint not null, is_allowed smallint not null, permission_id bigint not null, user_id bigint not null, primary key (id));
create table um_user_roles (role_id bigint not null, user_id bigint not null, primary key (user_id, role_id));

alter table um_role_attributes add constraint FKD869ED19F08E7776 foreign key (role_id) references um_roles ON DELETE CASCADE;
alter table um_role_permissions add constraint FK8ADF2902918A81D6 foreign key (permission_id) references um_permissions ON DELETE CASCADE;
alter table um_role_permissions add constraint FK8ADF2902F08E7776 foreign key (role_id) references um_roles ON DELETE CASCADE;
alter table um_user_attributes add constraint FK4BE38AA49B0BBA16 foreign key (user_id) references um_users ON DELETE CASCADE;
alter table um_user_permissions add constraint FK86993CD7918A81D6 foreign key (permission_id) references um_permissions ON DELETE CASCADE;
alter table um_user_permissions add constraint FK86993CD79B0BBA16 foreign key (user_id) references um_users ON DELETE CASCADE;
alter table um_user_roles add constraint FKFCA65150A3D254B4 foreign key (user_id) references um_users ON DELETE CASCADE;
alter table um_user_roles add constraint FKFCA65150F08E7776 foreign key (role_id) references um_roles ON DELETE CASCADE;
